; ============== Set SFR for ATmega328 ==================

; INTERRUPT VECTORS
     JMP  RESET
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00
     JMP  0x00

; Initialization SFR
RESET:
     CLI

; Set Stack Pointer to 0x08FF
     ldi  R21, high(RAMEND)
     out  SPH,R21
     ldi  R21, low(RAMEND)
     out  SPL,R21

; Disable EEPROM
     CLR  R21
     OUT  EECR,R21

; INTERRUPT VECTORS ARE PLACED AT THE START OF FLASH
     LDI  R22,1
     OUT  MCUCR,R22
     OUT  MCUCR,R21

; Crystal Oscillator division factor: 1
     LDI  R21,0x80
     LDI  R22,0x00
     STS  CLKPR,R21
     STS  CLKPR,R22

; Input/Output Ports initialization
; Port B initialization
; Func7=In Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=In
; State7=T State6=T State5=0 State4=P State3=P State2=P State1=P State0=P
     LDI  R21,0x1F         ; 0001.1111
     OUT  PORTB,R21
     LDI  R21,0x20         ; 0010.0000
     OUT  DDRB,R21
; Port C initialization
; Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; State6=P State5=P State4=P State3=P State2=P State1=P State0=P
     LDI  R21,0x7F
     OUT  PORTC,R21
     LDI  R21,0x00
     OUT  DDRC,R21
; Port D initialization
; Func7=In Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=In
; State7=T State6=0 State5=0 State4=0 State3=P State2=P State1=1 State0=T
     LDI  R21,0x0E          ; 0000.1110
     OUT  PORTD,R21
     LDI  R21,0x72          ; 0111.0010
     OUT  DDRD,R21

; Timer/Counter 0 initialization
; Clock source: System Clock
; Clock value: Timer 0 Stopped
; Mode: Normal top=0xFF
; OC0A output: Disconnected
; OC0B output: Disconnected
     LDI  R21,0x00
     OUT  TCCR0A,R21
     OUT  TCCR0B,R21
     OUT  TCNT0,R21
     OUT  OCR0A,R21
     OUT  OCR0B,R21

; Timer/Counter 1 initialization
; Clock source: System Clock
; Clock value: Timer1 Stopped
; Mode: Normal top=0xFFFF
; OC1A output: Discon.
; OC1B output: Discon.
; Noise Canceler: Off
; Input Capture on Falling Edge
; Timer1 Overflow Interrupt: Off
; Input Capture Interrupt: Off
; Compare A Match Interrupt: Off
; Compare B Match Interrupt: Off
     STS  TCCR1A,R21
     STS  TCCR1B,R21
     STS  TCNT1H,R21
     STS  TCNT1L,R21
     STS  ICR1H,R21
     STS  ICR1L,R21
     STS  OCR1AH,R21
     STS  OCR1AL,R21
     STS  OCR1BH,R21
     STS  OCR1BL,R21

; Timer/Counter 2 initialization
; Clock source: System Clock
; Clock value: Timer2 Stopped
; Mode: Normal top=0xFF
; OC2A output: Disconnected
; OC2B output: Disconnected
     STS  ASSR,R21
     STS  TCCR2A,R21
     STS  TCCR2B,R21
     STS  TCNT2,R21
     STS  OCR2A,R21
     STS  OCR2B,R21

; External Interrupt(s) initialization
; INT0: Off
; INT1: Off
; Interrupt on any change on pins PCINT0-7: Off
; Interrupt on any change on pins PCINT8-14: Off
; Interrupt on any change on pins PCINT16-23: Off
     STS  EICRA,R21
     OUT  EIMSK,R21
     STS  PCICR,R21

; Timer/Counter 0 Interrupt(s) initialization
     STS  TIMSK0,R21
; Timer/Counter 1 Interrupt(s) initialization
     STS  TIMSK1,R21
; Timer/Counter 2 Interrupt(s) initialization
     STS  TIMSK2,R21

; USART initialization
; Communication Parameters: 8 Data, 1 Stop, No Parity
; USART Receiver: On
; USART Transmitter: On
; USART0 Mode: Asynchronous
; USART Baud Rate: 57600
     STS  UCSR0A,R21
     LDI  R21,0x18
     STS  UCSR0B,R21
     LDI  R21,0x06
     STS  UCSR0C,R21
     LDI  R21,0x00
     STS  UBRR0H,R21
     LDI  R21,0x10
     STS  UBRR0L,R21

; Analog Comparator initialization
; Analog Comparator: Off
; Analog Comparator Input Capture by Timer/Counter 1: Off
     LDI  R21,0x80
     OUT  ACSR,R21
     LDI  R21,0x00
     STS  ADCSRB,R21
     STS  DIDR1,R21

; ADC initialization
; ADC disabled
     STS  ADCSRA,R21

; SPI initialization
; SPI disabled
     OUT  SPCR,R21

; TWI initialization
; TWI disabled
     STS  TWCR,R21

; Watchdog Timer initialization
; Watchdog Timer Prescaler: OSC/1024k
; Watchdog Timer interrupt: Off
     WDR
     LDI  R21,0x39
     LDI  R22,0x29
     STS  WDTCSR,R21
     STS  WDTCSR,R22

; End of initialization SFR

